import  java.io.*;
import  java.util.Scanner;

public class HeapSort {

    public static void printIndexes(int a[]) {
	int i;
	System.out.printf("\n------------------");
	for(i = 0; i < a.length; i++)
	    System.out.printf("%2d ",i+1);
	System.out.printf("----\n");
    }

    public static void printArray(int a[]) {
	int i;
	System.out.printf("[");
	for(i = 0; i < a.length; i++)
	    System.out.printf("%2d ",a[i]);
	System.out.printf("]\n");
    }

    public static void printSubArray(int a[], int l, int r) {
	int i;
	System.out.printf("[");
	for(i = 0; i < a.length; i++)
	  if (i>=l && i <= r)
	    System.out.printf("%2d ",a[i]);
          else
	    System.out.printf("   ");
	System.out.printf("]\n");
    }

   public static int[] readArray() {
    Scanner in = new Scanner(System.in);    
    System.out.print("Length of the array: ");
    int size = in.nextInt();
    int[] a = new int[size];
    for (int i = 0; i < size; i++) {
       System.out.print("Insert the "+(i+1)+"-th value: ");
       a[i] = in.nextInt();
    }
    return a;   
   } 

 
    public static void heapify(int a[], int i, int n) {
	int l = 2*(i+1)-1, r = 2*(i+1), m = i;
	if(l <= n && a[l] > a[m]) m = l;
	if(r <= n && a[r] > a[m]) m = r;
	if(i != m) {
	    int t = a[i]; 
            a[i] = a[m];
	    a[m] = t; 
            heapify(a,m,n);
	}
    } 

    public static void build(int a[]) {
	int i;
	for(i = a.length/2-1; i >= 0; i--)
	    heapify (a,i,a.length-1);
    }

    public static void heapsort(int a[])
    {
       	build(a);
System.out.print("use build_heap:  ");
        printArray(a);
	int i, c = a.length-1;
	for(i = a.length-1; i > 0; i--) {
	    int t = a[i]; a[i] = a[0]; a[0] = t;
System.out.printf("swap A[1],A[%2d]: ",c+1);
printArray(a);
            c--;
	    heapify(a,0,c);    
System.out.printf("heapify (1,%2d):  ",c+1);
printSubArray(a,0,c);
	}
    }

    public static void main(String args[]) {
	int[] a = readArray();
	printIndexes(a);
	System.out.printf("\nunsorted array:  ");
	printArray(a);
	heapsort(a);
	System.out.printf("\n  sorted array:  ");
	printArray(a);
    }
}
