import  java.io.*;
import  java.util.Scanner;

public class QuickSort {
// version by K.Ranalder

    public static void printIndexes(int a[]) {
	int i;
	System.out.printf("\n------------------------------");
	for(i = 0; i < a.length; i++)
	    System.out.printf("%2d ",i+1);
	System.out.printf("----\n");
    }

    public static void printArray(int a[]) {
	int i;
	System.out.printf("[");
	for(i = 0; i < a.length; i++)
	    System.out.printf("%2d ",a[i]);
	System.out.printf("]\n");
    }

    public static void printSubArray(int a[], int l, int r) {
	int i;
	System.out.printf("[");
	for(i = 0; i < a.length; i++)
	  if (i>=l && i <= r)
	    System.out.printf("%2d ",a[i]);
          else
	    System.out.printf("   ");
	System.out.printf("]\n");
    }

   public static int[] readArray() {
    Scanner in = new Scanner(System.in);    
    System.out.print("Length of the array: ");
    int size = in.nextInt();
    int[] a = new int[size];
    for (int i = 0; i < size; i++) {
       System.out.print("Insert the "+(i+1)+"-th value: ");
       a[i] = in.nextInt();
    }
    return a;   
   } 

    public static int partition(int a[], int l, int r) {
	int x =a[r], i = l-1, j, t;
	for(j = l; j < r; j++) {
	    if(a[j] <= x) {
                ++i;
		t = a[i];
		a[i] = a[j];
		a[j] = t;
	    }
	}
	t = a[r]; 
        a[r] = a[i+1];
	a[i+1] = t; 
        return i+1;
    } 

    public static void quicksort1(int a[], int l, int r) {
	int m;
	if(l < r) {
System.out.printf("---------  Sorting a[%2d,%2d]: ",(l+1),(r+1));
printSubArray(a,l,r);
	    m = partition(a, l, r);
System.out.printf("After partitioning a[%2d,%2d]: ",(l+1),(r+1));
printSubArray(a,l,r);
	    quicksort1(a, l, m-1);
	    quicksort1(a, m+1, r);
System.out.printf("After sorting      a[%2d,%2d]: ",(l+1),(r+1));
printSubArray(a,l,r);
	}
    }

    public static void quicksort(int a[]) {
         quicksort1(a, 0, a.length-1);
    }

    public static void main(String args[]) {
	int[] a = readArray();
	System.out.printf("\nunsorted array: ");
	printArray(a);
	printIndexes(a);
	quicksort(a);
	System.out.printf("\nsorted array: ");
	printArray(a);
    }
}
