import  java.io.*;
import  java.util.Scanner;
import  java.util.Random;

public class RandQuickSort {

    public static Random generator = new Random();

    public static void printIndexes(int a[]) {
	int i;
        System.out.printf("\n------------------------------");
	for(i = 0; i < a.length; i++)
	    System.out.printf("%2d ",i+1);
	System.out.printf("----\n");
    }

    public static void printArray(int a[]) {
	int i;
	System.out.printf("[");
	for(i = 0; i < a.length; i++)
	    System.out.printf("%2d ",a[i]);
	System.out.printf("]\n");
    }

    public static void printSubArray(int a[], int l, int r) {
	int i;
	System.out.printf("[");
	for(i = 0; i < a.length; i++)
	  if (i>=l && i <= r)
	    System.out.printf("%2d ",a[i]);
          else
	    System.out.printf("   ");
	System.out.printf("]\n");
    }

   public static int[] readArray() {
    Scanner in = new Scanner(System.in);    
    System.out.print("Length of the array: ");
    int size = in.nextInt();
    int[] a = new int[size];
    for (int i = 0; i < size; i++) {
       System.out.print("Insert the "+(i+1)+"-th value: ");
       a[i] = in.nextInt();
    }
    return a;   
   } 

    public static int partitionRand(int a[], int l, int r) {
	int x, i = l-1, j, t;
        int randIdx = generator.nextInt(r-l+1)+l; 
System.out.printf("--- Randomly selected: a[%2d]=%2d\n",randIdx+1,a[randIdx]);
System.out.printf("After swapping a[%2d], a[%2d]: ",randIdx+1,r+1);
        t = a[r];a[r]=a[randIdx];a[randIdx]=t;
printSubArray(a,l,r);
        x =a[r];
	for(j = l; j < r; j++) {
	    if(a[j] <= x) {
		t = a[++i];
		a[i] = a[j];
		a[j] = t;
	    }
	}
	t = a[r]; 
        a[r] = a[i+1];
	a[i+1] = t; 
        return i+1;
    } 

    public static void quicksortRand(int a[], int l, int r) {
	int m;
	if(l < r) {
System.out.printf("---------  Sorting a[%2d,%2d]: ",(l+1),(r+1));
printSubArray(a,l,r);
	    m = partitionRand(a, l, r);
System.out.printf("After partitioning a[%2d,%2d]: ",(l+1),(r+1));
printSubArray(a,l,r);
	    quicksortRand(a, l, m-1);
	    quicksortRand(a, m+1, r);
System.out.printf("After sorting      a[%2d,%2d]: ",(l+1),(r+1));
printSubArray(a,l,r);
	}
    }

    public static void quicksort(int a[]) {
         quicksortRand(a, 0, a.length-1);
    }

    public static void main(String args[]) {
	int[] a = readArray();
	System.out.printf("\nunsorted array: ");
	printArray(a);
	printIndexes(a);
	quicksort(a);
	System.out.printf("\nsorted array: ");
	printArray(a);
    }
}
